package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonUnwrapped;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntDeserializer;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntSerializer;
// UnionType: AccountType
// UnionValue: TokenAccount

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("TokenAccount")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class TokenAccount implements Account {
	public final AccountType type = AccountType.TOKEN_ACCOUNT;
	private Url url;
	@JsonUnwrapped
	private AccountAuth accountAuth;
	private Url tokenUrl;
	private java.math.BigInteger balance;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public TokenAccount url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public TokenAccount url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public AccountAuth getAccountAuth() {
	    return accountAuth;
	}
	public void setAccountAuth(final AccountAuth value) {
	    this.accountAuth = value;
	}

	public TokenAccount accountAuth(final AccountAuth value) {
	    setAccountAuth(value);
	    return this;
	}
	public Url getTokenUrl() {
	    return tokenUrl;
	}
	public void setTokenUrl(final Url value) {
	    this.tokenUrl = value;
	}

	public TokenAccount tokenUrl(final Url value) {
	    setTokenUrl(value);
	    return this;
	}
	public TokenAccount tokenUrl(final String value) {
	    setTokenUrl(Url.toAccURL(value));
	    return this;
	}
	@JsonDeserialize(using = GoBigIntDeserializer.class)
	public java.math.BigInteger getBalance() {
	    return balance;
	}
	@JsonSerialize(using = GoBigIntSerializer.class)
	public void setBalance(final java.math.BigInteger value) {
	    this.balance = value;
	}

	public TokenAccount balance(final java.math.BigInteger value) {
	    setBalance(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.accountAuth == null)) {
            marshaller.writeValue(3, accountAuth);
        }
        if (!(this.tokenUrl == null)) {
            marshaller.writeUrl(4, this.tokenUrl);
        }
        if (!((this.balance).equals(java.math.BigInteger.ZERO))) {
            marshaller.writeBigInt(5, this.balance);
        }
        return marshaller.array();
    }
}
